--- old/usr/src/lib/libuutil/common/libuutil.h	2015-09-10 10:06:57.580536277 -0400
+++ new/usr/src/lib/libuutil/common/libuutil.h	2015-09-10 10:06:57.586026502 -0400
@@ -359,6 +359,8 @@
 
 void uu_avl_destroy(uu_avl_t *);	/* list must be empty */
 
+void uu_avl_recreate(uu_avl_t *);
+
 size_t uu_avl_numnodes(uu_avl_t *);
 
 void *uu_avl_first(uu_avl_t *);
--- old/usr/src/lib/libuutil/common/mapfile-vers	2015-09-10 10:06:57.705876093 -0400
+++ new/usr/src/lib/libuutil/common/mapfile-vers	2015-09-10 10:06:57.709414179 -0400
@@ -56,6 +56,7 @@
 	uu_avl_pool_create;
 	uu_avl_pool_destroy;
 	uu_avl_prev;
+	uu_avl_recreate;
 	uu_avl_remove;
 	uu_avl_teardown;
 	uu_avl_walk;
--- old/usr/src/lib/libuutil/common/uu_avl.c	2015-09-10 10:06:57.819906357 -0400
+++ new/usr/src/lib/libuutil/common/uu_avl.c	2015-09-10 10:06:57.823546497 -0400
@@ -21,10 +21,10 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include "libuutil_common.h"
 
 #include <stdlib.h>
@@ -274,6 +274,16 @@
 	uu_free(ap);
 }
 
+void
+uu_avl_recreate(uu_avl_t *ap)
+{
+	uu_avl_pool_t *pp = ap->ua_pool;
+
+	avl_destroy(&ap->ua_tree);
+	avl_create(&ap->ua_tree, &uu_avl_node_compare, pp->uap_objsize,
+	    pp->uap_nodeoffset);
+}
+
 size_t
 uu_avl_numnodes(uu_avl_t *ap)
 {
--- old/usr/src/lib/libzfs/common/libzfs_config.c	2015-09-10 10:06:57.946560214 -0400
+++ new/usr/src/lib/libzfs/common/libzfs_config.c	2015-09-10 10:06:57.950079409 -0400
@@ -26,6 +26,7 @@
 
 /*
  * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*
@@ -167,7 +168,8 @@
 	zcmd_free_nvlists(&zc);
 
 	/*
-	 * Clear out any existing configuration information.
+	 * Clear out any existing configuration information, and recreate
+	 * the AVL tree.
 	 */
 	cookie = NULL;
 	while ((cn = uu_avl_teardown(hdl->libzfs_ns_avl, &cookie)) != NULL) {
@@ -176,6 +178,8 @@
 		free(cn);
 	}
 
+	uu_avl_recreate(hdl->libzfs_ns_avl);
+
 	elem = NULL;
 	while ((elem = nvlist_next_nvpair(config, elem)) != NULL) {
 		nvlist_t *child;
